Index: serefpolicy-contrib-20140730/telepathy.te
===================================================================
--- serefpolicy-contrib-20140730.orig/telepathy.te
+++ serefpolicy-contrib-20140730/telepathy.te
@@ -1,29 +1,28 @@
-policy_module(telepathy, 1.5.1)
+policy_module(telepathy, 1.4.2)
 
 ########################################
 #
-# Declarations
+# Declarations.
 #
 
 ## <desc>
-##	<p>
-##	Determine whether telepathy connection
-##	managers can connect to generic tcp ports.
-##	</p>
+## <p>
+## Allow the Telepathy connection managers
+## to connect to any generic TCP port.
+## </p>
 ## </desc>
 gen_tunable(telepathy_tcp_connect_generic_network_ports, false)
 
 ## <desc>
-##	<p>
-##	Determine whether telepathy connection
-##	managers can connect to any port.
-##	</p>
+## <p>
+## Allow the Telepathy connection managers
+## to connect to any network port.
+## </p>
 ## </desc>
 gen_tunable(telepathy_connect_all_ports, false)
 
 attribute telepathy_domain;
 attribute telepathy_executable;
-attribute telepathy_tmp_content;
 
 telepathy_domain_template(gabble)
 
@@ -67,179 +66,150 @@ userdom_user_home_content(telepathy_suns
 
 #######################################
 #
-# Gabble local policy
+# Telepathy Gabble local policy.
 #
 
-allow telepathy_gabble_t self:tcp_socket { accept listen };
+allow telepathy_gabble_t self:tcp_socket create_stream_socket_perms;
 allow telepathy_gabble_t self:unix_dgram_socket { create_socket_perms sendto };
 
-# ~/.cache/telepathy/gabble/caps-cache.db-journal
-manage_dirs_pattern(telepathy_gabble_t, telepathy_gabble_cache_home_t, telepathy_gabble_cache_home_t)
-manage_files_pattern(telepathy_gabble_t, telepathy_gabble_cache_home_t, telepathy_gabble_cache_home_t)
-filetrans_pattern(telepathy_gabble_t, telepathy_cache_home_t, telepathy_gabble_cache_home_t, dir, "gabble")
-# gnome_cache_filetrans(telepathy_gabble_t, telepathy_gabble_cache_home_t, dir, "wocky")
-
 manage_dirs_pattern(telepathy_gabble_t, telepathy_gabble_tmp_t, telepathy_gabble_tmp_t)
 manage_sock_files_pattern(telepathy_gabble_t, telepathy_gabble_tmp_t, telepathy_gabble_tmp_t)
 files_tmp_filetrans(telepathy_gabble_t, telepathy_gabble_tmp_t, { dir sock_file })
 
-corenet_all_recvfrom_unlabeled(telepathy_gabble_t)
+# ~/.cache/telepathy/gabble/caps-cache.db-journal
+optional_policy(`
+	manage_dirs_pattern(telepathy_gabble_t, telepathy_gabble_cache_home_t, telepathy_gabble_cache_home_t)
+	manage_files_pattern(telepathy_gabble_t, telepathy_gabble_cache_home_t, telepathy_gabble_cache_home_t)
+	filetrans_pattern(telepathy_gabble_t, telepathy_cache_home_t, telepathy_gabble_cache_home_t, dir)
+	# ~/.cache/wocky
+	gnome_cache_filetrans(telepathy_gabble_t, telepathy_gabble_cache_home_t, dir)
+')
+
 corenet_all_recvfrom_netlabel(telepathy_gabble_t)
 corenet_tcp_sendrecv_generic_if(telepathy_gabble_t)
 corenet_tcp_sendrecv_generic_node(telepathy_gabble_t)
-
-corenet_sendrecv_http_client_packets(telepathy_gabble_t)
 corenet_tcp_connect_http_port(telepathy_gabble_t)
-corenet_tcp_sendrecv_http_port(telepathy_gabble_t)
-
-corenet_sendrecv_jabber_client_client_packets(telepathy_gabble_t)
 corenet_tcp_connect_jabber_client_port(telepathy_gabble_t)
-corenet_tcp_sendrecv_jabber_client_port(telepathy_gabble_t)
-
-corenet_sendrecv_vnc_client_packets(telepathy_gabble_t)
 corenet_tcp_connect_vnc_port(telepathy_gabble_t)
-corenet_tcp_sendrecv_vnc_port(telepathy_gabble_t)
+corenet_sendrecv_http_client_packets(telepathy_gabble_t)
+corenet_sendrecv_jabber_client_client_packets(telepathy_gabble_t)
+corenet_sendrecv_vnc_client_packets(telepathy_gabble_t)
 
 dev_read_rand(telepathy_gabble_t)
 
 files_read_config_files(telepathy_gabble_t)
-files_read_usr_files(telepathy_gabble_t)
+
+fs_getattr_all_fs(telepathy_gabble_t)
 
 miscfiles_read_all_certs(telepathy_gabble_t)
 
 tunable_policy(`telepathy_connect_all_ports',`
-	corenet_sendrecv_all_client_packets(telepathy_gabble_t)
 	corenet_tcp_connect_all_ports(telepathy_gabble_t)
 	corenet_tcp_sendrecv_all_ports(telepathy_gabble_t)
+	corenet_udp_sendrecv_all_ports(telepathy_gabble_t)
 ')
 
 tunable_policy(`telepathy_tcp_connect_generic_network_ports',`
-	corenet_sendrecv_generic_client_packets(telepathy_gabble_t)
 	corenet_tcp_connect_generic_port(telepathy_gabble_t)
-	corenet_tcp_sendrecv_generic_port(telepathy_gabble_t)
+	corenet_sendrecv_generic_client_packets(telepathy_gabble_t)
 ')
 
-tunable_policy(`use_nfs_home_dirs',`
-	fs_manage_nfs_dirs(telepathy_gabble_t)
-	fs_manage_nfs_files(telepathy_gabble_t)
-')
-
-tunable_policy(`use_samba_home_dirs',`
-	fs_manage_cifs_dirs(telepathy_gabble_t)
-	fs_manage_cifs_files(telepathy_gabble_t)
-')
+userdom_home_manager(telepathy_gabble_t)
 
 optional_policy(`
 	dbus_system_bus_client(telepathy_gabble_t)
 ')
 
-# optional_policy(`
-	# ~/.config/dconf/user
-	# gnome_manage_generic_home_content(telepathy_gabble_t)
-# ')
+optional_policy(`
+	gnome_manage_home_config(telepathy_gabble_t)
+')
 
 #######################################
 #
-# Idle local policy
+# Telepathy Idle local policy.
 #
 
 corenet_all_recvfrom_netlabel(telepathy_idle_t)
-corenet_all_recvfrom_unlabeled(telepathy_idle_t)
 corenet_tcp_sendrecv_generic_if(telepathy_idle_t)
 corenet_tcp_sendrecv_generic_node(telepathy_idle_t)
-
-corenet_sendrecv_gatekeeper_client_packets(telepathy_idle_t)
 corenet_tcp_connect_gatekeeper_port(telepathy_idle_t)
-corenet_tcp_sendrecv_gatekeeper_port(telepathy_idle_t)
-
-corenet_sendrecv_ircd_client_packets(telepathy_idle_t)
 corenet_tcp_connect_ircd_port(telepathy_idle_t)
-corenet_tcp_sendrecv_ircd_port(telepathy_idle_t)
+corenet_sendrecv_ircd_client_packets(telepathy_idle_t)
 
 dev_read_rand(telepathy_idle_t)
 
-files_read_usr_files(telepathy_idle_t)
-
 tunable_policy(`telepathy_connect_all_ports',`
-	corenet_sendrecv_all_client_packets(telepathy_idle_t)
 	corenet_tcp_connect_all_ports(telepathy_idle_t)
 	corenet_tcp_sendrecv_all_ports(telepathy_idle_t)
+	corenet_udp_sendrecv_all_ports(telepathy_idle_t)
 ')
 
 tunable_policy(`telepathy_tcp_connect_generic_network_ports',`
-	corenet_sendrecv_generic_client_packets(telepathy_idle_t)
 	corenet_tcp_connect_generic_port(telepathy_idle_t)
-	corenet_tcp_sendrecv_generic_port(telepathy_idle_t)
+	corenet_sendrecv_generic_client_packets(telepathy_idle_t)
 ')
 
 #######################################
 #
-# Logger local policy
+# Telepathy Logger local policy.
 #
 
 allow telepathy_logger_t self:unix_stream_socket create_socket_perms;
 
 manage_dirs_pattern(telepathy_logger_t, telepathy_logger_cache_home_t, telepathy_logger_cache_home_t)
 manage_files_pattern(telepathy_logger_t, telepathy_logger_cache_home_t, telepathy_logger_cache_home_t)
-filetrans_pattern(telepathy_logger_t, telepathy_cache_home_t, telepathy_logger_cache_home_t, dir, "logger")
+filetrans_pattern(telepathy_logger_t, telepathy_cache_home_t, telepathy_logger_cache_home_t, dir)
 
 manage_dirs_pattern(telepathy_logger_t, telepathy_logger_data_home_t, telepathy_logger_data_home_t)
 manage_files_pattern(telepathy_logger_t, telepathy_logger_data_home_t, telepathy_logger_data_home_t)
-# gnome_data_filetrans(telepathy_logger_t, telepathy_logger_data_home_t, dir, "TpLogger")
 
-files_read_usr_files(telepathy_logger_t)
+optional_policy(`
+	gnome_data_filetrans(telepathy_logger_t, telepathy_logger_data_home_t, dir)
+')
+
 files_search_pids(telepathy_logger_t)
 
-tunable_policy(`use_nfs_home_dirs',`
-	fs_manage_nfs_dirs(telepathy_logger_t)
-	fs_manage_nfs_files(telepathy_logger_t)
-')
+fs_getattr_all_fs(telepathy_logger_t)
 
-tunable_policy(`use_samba_home_dirs',`
-	fs_manage_cifs_dirs(telepathy_logger_t)
-	fs_manage_cifs_files(telepathy_logger_t)
-')
+userdom_home_manager(telepathy_logger_t)
 
-# optional_policy(`
+optional_policy(`
 	# ~/.config/dconf/user
-	# gnome_manage_generic_home_content(telepathy_logger_t)
-# ')
+	gnome_manage_home_config(telepathy_logger_t)
+')
 
 #######################################
 #
-# Mission-Control local policy
+# Telepathy Mission-Control local policy.
 #
-
 allow telepathy_mission_control_t self:process setsched;
 
 manage_dirs_pattern(telepathy_mission_control_t, telepathy_mission_control_home_t, telepathy_mission_control_home_t)
 manage_files_pattern(telepathy_mission_control_t, telepathy_mission_control_home_t, telepathy_mission_control_home_t)
-userdom_user_home_dir_filetrans(telepathy_mission_control_t, telepathy_mission_control_home_t, dir, ".mission-control")
+userdom_search_user_home_dirs(telepathy_mission_control_t)
 
-manage_dirs_pattern(telepathy_mission_control_t, telepathy_mission_control_data_home_t, telepathy_mission_control_data_home_t)
+manage_files_pattern(telepathy_mission_control_t, telepathy_gabble_cache_home_t, telepathy_gabble_cache_home_t)
+manage_dirs_pattern(telepathy_mission_control_t, telepathy_gabble_cache_home_t, telepathy_gabble_cache_home_t)
+
+manage_dirs_pattern(telepathy_mission_control_t, { telepathy_data_home_t telepathy_mission_control_data_home_t }, { telepathy_data_home_t telepathy_mission_control_data_home_t })
 manage_files_pattern(telepathy_mission_control_t, telepathy_mission_control_data_home_t, telepathy_mission_control_data_home_t)
-filetrans_pattern(telepathy_mission_control_t, telepathy_data_home_t, telepathy_mission_control_data_home_t, dir, "mission-control")
+filetrans_pattern(telepathy_mission_control_t, telepathy_data_home_t, telepathy_mission_control_data_home_t, { dir file })
 
-manage_files_pattern(telepathy_mission_control_t, telepathy_mission_control_cache_home_t, telepathy_mission_control_cache_home_t)
-# gnome_cache_filetrans(telepathy_mission_control_t, telepathy_mission_control_cache_home_t, file, ".mc_connections")
+optional_policy(`
+	gnome_data_filetrans(telepathy_mission_control_t, telepathy_data_home_t, dir)
+	gnome_manage_home_config(telepathy_mission_control_t)
+')
 
 manage_dirs_pattern(telepathy_mission_control_t, telepathy_gabble_cache_home_t, telepathy_gabble_cache_home_t)
 manage_files_pattern(telepathy_mission_control_t, telepathy_gabble_cache_home_t, telepathy_gabble_cache_home_t)
 
 dev_read_rand(telepathy_mission_control_t)
 
-files_list_tmp(telepathy_mission_control_t)
-files_read_usr_files(telepathy_mission_control_t)
+fs_getattr_all_fs(telepathy_mission_control_t)
 
-tunable_policy(`use_nfs_home_dirs',`
-	fs_manage_nfs_dirs(telepathy_mission_control_t)
-	fs_manage_nfs_files(telepathy_mission_control_t)
-')
+files_list_tmp(telepathy_mission_control_t)
 
-tunable_policy(`use_samba_home_dirs',`
-	fs_manage_cifs_dirs(telepathy_mission_control_t)
-	fs_manage_cifs_files(telepathy_mission_control_t)
-')
+userdom_home_manager(telepathy_mission_control_t)
 
 optional_policy(`
 	dbus_system_bus_client(telepathy_mission_control_t)
@@ -248,59 +218,51 @@ optional_policy(`
 		devicekit_dbus_chat_power(telepathy_mission_control_t)
 	')
 	optional_policy(`
-		gnome_dbus_chat_all_gkeyringd(telepathy_mission_control_t)
+		gnome_dbus_chat_gkeyringd(telepathy_mission_control_t)
 	')
 	optional_policy(`
 		networkmanager_dbus_chat(telepathy_mission_control_t)
 	')
 ')
 
-# optional_policy(`
-	# ~/.config/dconf/user
-	# gnome_manage_generic_home_content(telepathy_mission_control_t)
-# ')
+# ~/.cache/.mc_connections.
+optional_policy(`
+	manage_files_pattern(telepathy_mission_control_t, telepathy_mission_control_cache_home_t, telepathy_mission_control_cache_home_t)
+	gnome_cache_filetrans(telepathy_mission_control_t, telepathy_mission_control_cache_home_t, file)
+')
 
 #######################################
 #
-# Butterfly and Haze local policy
+# Telepathy Butterfly and Haze local policy.
 #
 
 allow telepathy_msn_t self:process setsched;
+allow telepathy_msn_t self:unix_dgram_socket { write create connect };
 
 manage_dirs_pattern(telepathy_msn_t, telepathy_msn_tmp_t, telepathy_msn_tmp_t)
 manage_files_pattern(telepathy_msn_t, telepathy_msn_tmp_t, telepathy_msn_tmp_t)
 manage_sock_files_pattern(telepathy_msn_t, telepathy_msn_tmp_t, telepathy_msn_tmp_t)
+exec_files_pattern(telepathy_msn_t, telepathy_msn_tmp_t, telepathy_msn_tmp_t)
 files_tmp_filetrans(telepathy_msn_t, telepathy_msn_tmp_t, { dir file sock_file })
-
 userdom_user_tmp_filetrans(telepathy_msn_t, telepathy_msn_tmp_t, { dir file sock_file })
-
+userdom_dontaudit_setattr_user_tmp(telepathy_msn_t)
 can_exec(telepathy_msn_t, telepathy_msn_tmp_t)
 
 corenet_all_recvfrom_netlabel(telepathy_msn_t)
-corenet_all_recvfrom_unlabeled(telepathy_msn_t)
 corenet_tcp_sendrecv_generic_if(telepathy_msn_t)
 corenet_tcp_sendrecv_generic_node(telepathy_msn_t)
-
-corenet_sendrecv_http_client_packets(telepathy_msn_t)
+corenet_tcp_bind_generic_node(telepathy_msn_t)
 corenet_tcp_connect_http_port(telepathy_msn_t)
-corenet_tcp_sendrecv_http_port(telepathy_msn_t)
-
-corenet_sendrecv_mmcc_client_packets(telepathy_msn_t)
 corenet_tcp_connect_mmcc_port(telepathy_msn_t)
-corenet_tcp_sendrecv_mmcc_port(telepathy_msn_t)
-
-corenet_sendrecv_msnp_client_packets(telepathy_msn_t)
 corenet_tcp_connect_msnp_port(telepathy_msn_t)
-corenet_tcp_sendrecv_msnp_port(telepathy_msn_t)
-
-corenet_sendrecv_sip_client_packets(telepathy_msn_t)
 corenet_tcp_connect_sip_port(telepathy_msn_t)
-corenet_tcp_sendrecv_sip_port(telepathy_msn_t)
+corenet_sendrecv_http_client_packets(telepathy_msn_t)
+corenet_sendrecv_mmcc_client_packets(telepathy_msn_t)
+corenet_sendrecv_msnp_client_packets(telepathy_msn_t)
 
 corecmd_exec_bin(telepathy_msn_t)
 corecmd_exec_shell(telepathy_msn_t)
-
-files_read_usr_files(telepathy_msn_t)
+corecmd_read_bin_symlinks(telepathy_msn_t)
 
 init_read_state(telepathy_msn_t)
 
@@ -310,18 +272,19 @@ logging_send_syslog_msg(telepathy_msn_t)
 
 miscfiles_read_all_certs(telepathy_msn_t)
 
-# userdom_dontaudit_setattr_user_tmp(telepathy_msn_t)
-
 tunable_policy(`telepathy_connect_all_ports',`
-	corenet_sendrecv_all_client_packets(telepathy_msn_t)
 	corenet_tcp_connect_all_ports(telepathy_msn_t)
 	corenet_tcp_sendrecv_all_ports(telepathy_msn_t)
+	corenet_udp_sendrecv_all_ports(telepathy_msn_t)
 ')
 
 tunable_policy(`telepathy_tcp_connect_generic_network_ports',`
-	corenet_sendrecv_generic_client_packets(telepathy_msn_t)
 	corenet_tcp_connect_generic_port(telepathy_msn_t)
-	corenet_tcp_sendrecv_generic_port(telepathy_msn_t)
+	corenet_sendrecv_generic_client_packets(telepathy_msn_t)
+')
+
+optional_policy(`
+	gnome_read_gconf_home_files(telepathy_msn_t)
 ')
 
 optional_policy(`
@@ -332,43 +295,33 @@ optional_policy(`
 	')
 ')
 
-# optional_policy(`
-	# ~/.config/dconf/user
-	# gnome_manage_generic_home_content(telepathy_msn_t)
-# ')
-
 #######################################
 #
-# Salut local policy
+# Telepathy Salut local policy.
 #
 
-allow telepathy_salut_t self:tcp_socket { accept listen };
+allow telepathy_salut_t self:tcp_socket create_stream_socket_perms;
 
 manage_sock_files_pattern(telepathy_salut_t, telepathy_salut_tmp_t, telepathy_salut_tmp_t)
 files_tmp_filetrans(telepathy_salut_t, telepathy_salut_tmp_t, sock_file)
 
 corenet_all_recvfrom_netlabel(telepathy_salut_t)
-corenet_all_recvfrom_unlabeled(telepathy_salut_t)
 corenet_tcp_sendrecv_generic_if(telepathy_salut_t)
 corenet_tcp_sendrecv_generic_node(telepathy_salut_t)
 corenet_tcp_bind_generic_node(telepathy_salut_t)
-
-corenet_sendrecv_presence_server_packets(telepathy_salut_t)
 corenet_tcp_bind_presence_port(telepathy_salut_t)
-corenet_sendrecv_presence_client_packets(telepathy_salut_t)
 corenet_tcp_connect_presence_port(telepathy_salut_t)
-corenet_tcp_sendrecv_presence_port(telepathy_salut_t)
+corenet_sendrecv_presence_server_packets(telepathy_salut_t)
 
 tunable_policy(`telepathy_connect_all_ports',`
-	corenet_sendrecv_all_client_packets(telepathy_salut_t)
 	corenet_tcp_connect_all_ports(telepathy_salut_t)
 	corenet_tcp_sendrecv_all_ports(telepathy_salut_t)
+	corenet_udp_sendrecv_all_ports(telepathy_salut_t)
 ')
 
 tunable_policy(`telepathy_tcp_connect_generic_network_ports',`
-	corenet_sendrecv_generic_client_packets(telepathy_salut_t)
 	corenet_tcp_connect_generic_port(telepathy_salut_t)
-	corenet_tcp_sendrecv_generic_port(telepathy_salut_t)
+	corenet_sendrecv_generic_client_packets(telepathy_salut_t)
 ')
 
 optional_policy(`
@@ -381,73 +334,53 @@ optional_policy(`
 
 #######################################
 #
-# Sofiasip local policy
+# Telepathy Sofiasip local policy.
 #
 
-allow telepathy_sofiasip_t self:rawip_socket create_stream_socket_perms;
-allow telepathy_sofiasip_t self:tcp_socket { accept listen };
+allow telepathy_sofiasip_t self:rawip_socket { create_socket_perms listen };
+allow telepathy_sofiasip_t self:tcp_socket create_stream_socket_perms;
 
 corenet_all_recvfrom_netlabel(telepathy_sofiasip_t)
-corenet_all_recvfrom_unlabeled(telepathy_sofiasip_t)
 corenet_tcp_sendrecv_generic_if(telepathy_sofiasip_t)
 corenet_raw_sendrecv_generic_if(telepathy_sofiasip_t)
 corenet_raw_sendrecv_generic_node(telepathy_sofiasip_t)
 corenet_tcp_sendrecv_generic_node(telepathy_sofiasip_t)
 corenet_tcp_bind_generic_node(telepathy_sofiasip_t)
 corenet_raw_bind_generic_node(telepathy_sofiasip_t)
-
-corenet_sendrecv_all_server_packets(telepathy_sofiasip_t)
 corenet_tcp_bind_all_unreserved_ports(telepathy_sofiasip_t)
-corenet_tcp_sendrecv_all_ports(telepathy_sofiasip_t)
-
 corenet_dontaudit_tcp_bind_all_ports(telepathy_sofiasip_t)
-
-corenet_sendrecv_sip_client_packets(telepathy_sofiasip_t)
 corenet_tcp_connect_sip_port(telepathy_sofiasip_t)
-corenet_tcp_sendrecv_sip_port(telepathy_sofiasip_t)
+corenet_sendrecv_sip_client_packets(telepathy_sofiasip_t)
 
 kernel_request_load_module(telepathy_sofiasip_t)
 
 tunable_policy(`telepathy_connect_all_ports',`
-	corenet_sendrecv_all_client_packets(telepathy_sofiasip_t)
 	corenet_tcp_connect_all_ports(telepathy_sofiasip_t)
 	corenet_tcp_sendrecv_all_ports(telepathy_sofiasip_t)
+	corenet_udp_sendrecv_all_ports(telepathy_sofiasip_t)
 ')
 
 tunable_policy(`telepathy_tcp_connect_generic_network_ports',`
-	corenet_sendrecv_generic_client_packets(telepathy_sofiasip_t)
 	corenet_tcp_connect_generic_port(telepathy_sofiasip_t)
-	corenet_tcp_sendrecv_generic_port(telepathy_sofiasip_t)
+	corenet_sendrecv_generic_client_packets(telepathy_sofiasip_t)
 ')
 
 #######################################
 #
-# Sunshine local policy
+# Telepathy Sunshine local policy.
 #
 
 manage_dirs_pattern(telepathy_sunshine_t, telepathy_sunshine_home_t, telepathy_sunshine_home_t)
 manage_files_pattern(telepathy_sunshine_t, telepathy_sunshine_home_t, telepathy_sunshine_home_t)
-userdom_user_home_dir_filetrans(telepathy_sunshine_t, telepathy_sunshine_home_t, dir, ".telepathy-sunshine")
+userdom_user_home_dir_filetrans(telepathy_sunshine_t, telepathy_sunshine_home_t, { dir file })
+userdom_search_user_home_dirs(telepathy_sunshine_t)
 
 manage_files_pattern(telepathy_sunshine_t, telepathy_sunshine_tmp_t, telepathy_sunshine_tmp_t)
+exec_files_pattern(telepathy_sunshine_t, telepathy_sunshine_tmp_t, telepathy_sunshine_tmp_t)
 files_tmp_filetrans(telepathy_sunshine_t, telepathy_sunshine_tmp_t, file)
 
-can_exec(telepathy_sunshine_t, telepathy_sunshine_tmp_t)
-
 corecmd_exec_bin(telepathy_sunshine_t)
 
-files_read_usr_files(telepathy_sunshine_t)
-
-tunable_policy(`use_nfs_home_dirs',`
-	fs_manage_nfs_dirs(telepathy_sunshine_t)
-	fs_manage_nfs_files(telepathy_sunshine_t)
-')
-
-tunable_policy(`use_samba_home_dirs',`
-	fs_manage_cifs_dirs(telepathy_sunshine_t)
-	fs_manage_cifs_files(telepathy_sunshine_t)
-')
-
 optional_policy(`
 	xserver_read_xdm_pid(telepathy_sunshine_t)
 	xserver_stream_connect(telepathy_sunshine_t)
@@ -455,31 +388,49 @@ optional_policy(`
 
 #######################################
 #
-# Common telepathy domain local policy
+# telepathy domains common policy
 #
 
 allow telepathy_domain self:process { getsched signal sigkill };
 allow telepathy_domain self:fifo_file rw_fifo_file_perms;
+allow telepathy_domain self:tcp_socket create_socket_perms;
+allow telepathy_domain self:udp_socket create_socket_perms;
 
 manage_dirs_pattern(telepathy_domain, telepathy_cache_home_t, telepathy_cache_home_t)
-# gnome_cache_filetrans(telepathy_domain, telepathy_cache_home_t, dir, "telepathy")
-
-manage_dirs_pattern(telepathy_domain, telepathy_data_home_t, telepathy_data_home_t)
-# gnome_data_filetrans(telepathy_domain, telepathy_data_home_t, dir, "telepathy")
+optional_policy(`
+	gnome_cache_filetrans(telepathy_domain, telepathy_cache_home_t, dir, "telepathy")
+')
 
 dev_read_urand(telepathy_domain)
 
-kernel_read_system_state(telepathy_domain)
 
 fs_getattr_all_fs(telepathy_domain)
 fs_search_auto_mountpoints(telepathy_domain)
+fs_rw_inherited_tmpfs_files(telepathy_domain)
 
-miscfiles_read_localization(telepathy_domain)
+userdom_search_user_tmp_dirs(telepathy_domain)
+userdom_search_user_home_dirs(telepathy_domain)
 
 optional_policy(`
 	automount_dontaudit_getattr_tmp_dirs(telepathy_domain)
 ')
 
 optional_policy(`
+	gnome_read_generic_cache_files(telepathy_domain)
+	gnome_write_generic_cache_files(telepathy_domain)
+	gnome_filetrans_config_home_content(telepathy_domain)
+')
+
+optional_policy(`
+	systemd_dbus_chat_logind(telepathy_domain)
+	systemd_write_inhibit_pipes(telepathy_domain)
+')
+
+optional_policy(`
+	telepathy_dbus_chat(telepathy_domain)
+')
+
+optional_policy(`
 	xserver_rw_xdm_pipes(telepathy_domain)
 ')
+
Index: serefpolicy-contrib-20140730/telnet.te
===================================================================
--- serefpolicy-contrib-20140730.orig/telnet.te
+++ serefpolicy-contrib-20140730/telnet.te
@@ -1,4 +1,4 @@
-policy_module(telnet, 1.12.0)
+policy_module(telnet, 1.11.3)
 
 ########################################
 #
@@ -30,16 +30,19 @@ files_pid_file(telnetd_var_run_t)
 allow telnetd_t self:capability { fsetid chown fowner setuid setgid sys_tty_config dac_override };
 allow telnetd_t self:process signal_perms;
 allow telnetd_t self:fifo_file rw_fifo_file_perms;
-allow telnetd_t self:tcp_socket { accept listen };
+allow telnetd_t self:tcp_socket connected_stream_socket_perms;
+allow telnetd_t self:udp_socket create_socket_perms;
+# for identd; cjp: this should probably only be inetd_child rules?
+allow telnetd_t self:netlink_tcpdiag_socket r_netlink_socket_perms;
 
 allow telnetd_t telnetd_devpts_t:chr_file { rw_chr_file_perms setattr_chr_file_perms };
+
 term_create_pty(telnetd_t, telnetd_devpts_t)
 
 allow telnetd_t telnetd_keytab_t:file read_file_perms;
 
 manage_dirs_pattern(telnetd_t, telnetd_tmp_t, telnetd_tmp_t)
 manage_files_pattern(telnetd_t, telnetd_tmp_t, telnetd_tmp_t)
-files_tmp_filetrans(telnetd_t, telnetd_tmp_t, { file dir })
 
 manage_files_pattern(telnetd_t, telnetd_var_run_t, telnetd_var_run_t)
 files_pid_filetrans(telnetd_t, telnetd_var_run_t, file)
@@ -48,7 +51,6 @@ kernel_read_kernel_sysctls(telnetd_t)
 kernel_read_system_state(telnetd_t)
 kernel_read_network_state(telnetd_t)
 
-corenet_all_recvfrom_unlabeled(telnetd_t)
 corenet_all_recvfrom_netlabel(telnetd_t)
 corenet_tcp_sendrecv_generic_if(telnetd_t)
 corenet_tcp_sendrecv_generic_node(telnetd_t)
@@ -63,7 +65,6 @@ dev_read_urand(telnetd_t)
 
 domain_interactive_fd(telnetd_t)
 
-files_read_usr_files(telnetd_t)
 files_read_etc_runtime_files(telnetd_t)
 files_search_home(telnetd_t)
 
@@ -76,12 +77,12 @@ init_rw_utmp(telnetd_t)
 
 logging_send_syslog_msg(telnetd_t)
 
-miscfiles_read_localization(telnetd_t)
-
 seutil_read_config(telnetd_t)
 
 userdom_search_user_home_dirs(telnetd_t)
 userdom_setattr_user_ptys(telnetd_t)
+userdom_manage_user_tmp_files(telnetd_t)
+userdom_tmp_filetrans_user_tmp(telnetd_t, file)
 
 tunable_policy(`use_nfs_home_dirs',`
 	fs_search_nfs(telnetd_t)
@@ -93,7 +94,7 @@ tunable_policy(`use_samba_home_dirs',`
 
 optional_policy(`
 	kerberos_read_keytab(telnetd_t)
-	kerberos_tmp_filetrans_host_rcache(telnetd_t, file, "host_0")
+	kerberos_tmp_filetrans_host_rcache(telnetd_t, "host_0")
 	kerberos_manage_host_rcache(telnetd_t)
 	kerberos_use(telnetd_t)
 ')
Index: serefpolicy-contrib-20140730/tftp.fc
===================================================================
--- serefpolicy-contrib-20140730.orig/tftp.fc
+++ serefpolicy-contrib-20140730/tftp.fc
@@ -1,11 +1,9 @@
-/etc/(x)?inetd\.d/tftp	--	gen_context(system_u:object_r:tftpd_conf_t,s0)
-
-/usr/bin/tftpd		--	gen_context(system_u:object_r:tftpd_exec_t,s0)
+/etc/(x)?inetd\.d/tftp	--	gen_context(system_u:object_r:tftpd_etc_t,s0)
 
 /usr/sbin/atftpd	--	gen_context(system_u:object_r:tftpd_exec_t,s0)
 /usr/sbin/in\.tftpd	--	gen_context(system_u:object_r:tftpd_exec_t,s0)
 
-/tftpboot	-d	gen_context(system_u:object_r:tftpdir_t,s0)
-/tftpboot/.*	gen_context(system_u:object_r:tftpdir_t,s0)
+/tftpboot		-d	gen_context(system_u:object_r:tftpdir_t,s0)
+/tftpboot/.*			gen_context(system_u:object_r:tftpdir_t,s0)
 
-/var/lib/tftpboot(/.*)?	gen_context(system_u:object_r:tftpdir_rw_t,s0)
+/var/lib/tftpboot(/.*)?		gen_context(system_u:object_r:tftpdir_rw_t,s0)
Index: serefpolicy-contrib-20140730/tftp.if
===================================================================
--- serefpolicy-contrib-20140730.orig/tftp.if
+++ serefpolicy-contrib-20140730/tftp.if
@@ -1,8 +1,8 @@
-## <summary>Trivial file transfer protocol daemon.</summary>
+## <summary>Trivial file transfer protocol daemon</summary>
 
 ########################################
 ## <summary>
-##	Read tftp content files.
+##	Read tftp content
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -13,18 +13,21 @@
 interface(`tftp_read_content',`
 	gen_require(`
 		type tftpdir_t;
+		type tftpdir_rw_t;
 	')
 
-	files_search_var_lib($1)
-	allow $1 tftpdir_t:dir list_dir_perms;
-	allow $1 tftpdir_t:file read_file_perms;
-	allow $1 tftpdir_t:lnk_file read_lnk_file_perms;
+	list_dirs_pattern($1, tftpdir_t, tftpdir_t)
+	read_files_pattern($1, tftpdir_t, tftpdir_t)
+	read_lnk_files_pattern($1, tftpdir_t, tftpdir_t)
+
+	list_dirs_pattern($1, tftpdir_rw_t, tftpdir_rw_t)
+	read_files_pattern($1, tftpdir_rw_t, tftpdir_rw_t)
+	read_lnk_files_pattern($1, tftpdir_rw_t, tftpdir_rw_t)
 ')
 
 ########################################
 ## <summary>
-##	Create, read, write, and delete
-##	tftp rw content.
+##	Search tftp /var/lib directories.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -32,20 +35,18 @@ interface(`tftp_read_content',`
 ##	</summary>
 ## </param>
 #
-interface(`tftp_manage_rw_content',`
+interface(`tftp_search_rw_content',`
 	gen_require(`
 		type tftpdir_rw_t;
 	')
 
+	search_dirs_pattern($1, tftpdir_rw_t, tftpdir_rw_t)
 	files_search_var_lib($1)
-	allow $1 tftpdir_rw_t:dir manage_dir_perms;
-	allow $1 tftpdir_rw_t:file manage_file_perms;
-	allow $1 tftpdir_rw_t:lnk_file manage_lnk_file_perms;
 ')
 
 ########################################
 ## <summary>
-##	Read tftpd configuration files.
+##	Allow read tftp /var/lib files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -53,19 +54,18 @@ interface(`tftp_manage_rw_content',`
 ##	</summary>
 ## </param>
 #
-interface(`tftp_read_config_files',`
+interface(`tftp_read_rw_content',`
 	gen_require(`
-		type tftpd_conf_t;
+		type tftpdir_rw_t;
 	')
 
-	files_search_etc($1)
-	allow $1 tftpd_conf_t:file read_file_perms;
+	files_search_var_lib($1)
+	read_files_pattern($1, tftpdir_rw_t, tftpdir_rw_t)
 ')
 
 ########################################
 ## <summary>
-##	Create, read, write, and delete
-##	tftpd configuration files.
+##	Allow write tftp /var/lib files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -73,55 +73,83 @@ interface(`tftp_read_config_files',`
 ##	</summary>
 ## </param>
 #
-interface(`tftp_manage_config_files',`
+interface(`tftp_write_rw_content',`
 	gen_require(`
-		type tftpd_conf_t;
+		type tftpdir_rw_t;
 	')
 
-	files_search_etc($1)
-	allow $1 tftpd_conf_t:file manage_file_perms;
+	files_search_var_lib($1)
+	write_files_pattern($1, tftpdir_rw_t, tftpdir_rw_t)
 ')
 
 ########################################
 ## <summary>
-##	Create objects in etc directories
-##	with tftp conf type.
+##	Manage tftp /var/lib files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
-##	Domain allowed to transition.
+##	Domain allowed access.
 ##	</summary>
 ## </param>
-## <param name="object_class">
+#
+interface(`tftp_manage_rw_content',`
+	gen_require(`
+		type tftpdir_rw_t;
+	')
+
+	files_search_var_lib($1)
+	manage_dirs_pattern($1, tftpdir_rw_t, tftpdir_rw_t)
+	manage_files_pattern($1, tftpdir_rw_t, tftpdir_rw_t)
+')
+
+########################################
+## <summary>
+##	Read tftp config files.
+## </summary>
+## <param name="domain">
 ##	<summary>
-##	Class of the object being created.
+##	Domain allowed access.
 ##	</summary>
 ## </param>
-## <param name="name" optional="true">
+#
+interface(`tftp_read_config',`
+	gen_require(`
+		type tftpd_etc_t;
+	')
+
+	read_files_pattern($1, tftpd_etc_t, tftpd_etc_t)
+')
+
+########################################
+## <summary>
+##	Manage tftp config files.
+## </summary>
+## <param name="domain">
 ##	<summary>
-##	The name of the object being created.
+##	Domain allowed access.
 ##	</summary>
 ## </param>
 #
-interface(`tftp_etc_filetrans_config',`
+interface(`tftp_manage_config',`
 	gen_require(`
-		type tftp_conf_t;
+		type tftpd_etc_t;
 	')
 
-	files_etc_filetrans($1, tftp_conf_t, $2, $3)
+ 	manage_files_pattern($1, tftpd_etc_t, tftpd_etc_t)
+	files_etc_filetrans($1, tftpd_etc_t, file, "tftp")
 ')
 
 ########################################
 ## <summary>
 ##	Create objects in tftpdir directories
-##	with a private type.
+##	with specified types.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
 ##	Domain allowed access.
 ##	</summary>
 ## </param>
-## <param name="private_type">
+## <param name="file_type">
 ##	<summary>
 ##	Private file type.
 ##	</summary>
@@ -131,25 +159,38 @@ interface(`tftp_etc_filetrans_config',`
 ##	Class of the object being created.
 ##	</summary>
 ## </param>
-## <param name="name" optional="true">
-##	<summary>
-##	The name of the object being created.
-##	</summary>
-## </param>
 #
 interface(`tftp_filetrans_tftpdir',`
 	gen_require(`
 		type tftpdir_rw_t;
 	')
 
+	filetrans_pattern($1, tftpdir_rw_t, $2, $3)
 	files_search_var_lib($1)
-	filetrans_pattern($1, tftpdir_rw_t, $2, $3, $4)
 ')
 
 ########################################
 ## <summary>
-##	All of the rules required to
-##	administrate an tftp environment.
+##	Transition to tftp named content
+## </summary>
+## <param name="domain">
+##	<summary>
+##      Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`tftp_filetrans_named_content',`
+	gen_require(`
+		type tftpd_etc_t;
+	')
+
+	files_etc_filetrans($1, tftpd_etc_t, file, "tftp")
+')
+
+########################################
+## <summary>
+##	All of the rules required to administrate
+##	an tftp environment
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -161,18 +202,22 @@ interface(`tftp_filetrans_tftpdir',`
 interface(`tftp_admin',`
 	gen_require(`
 		type tftpd_t, tftpdir_t, tftpdir_rw_t, tftpd_var_run_t;
-		type tftpd_conf_t;
 	')
 
-	allow $1 tftpd_t:process { ptrace signal_perms };
+	allow $1 tftpd_t:process signal_perms;
 	ps_process_pattern($1, tftpd_t)
+	tunable_policy(`deny_ptrace',`',`
+		allow $1 tftpd_t:process ptrace;
+	')
 
-	files_search_etc($1)
-	admin_pattern($1, tftpd_conf_t)
+	files_list_var_lib($1)
 
-	files_search_var_lib($1)
-	admin_pattern($1, { tftpdir_t tftpdir_rw_t })
+	admin_pattern($1, tftpdir_rw_t)
+
+	admin_pattern($1, tftpdir_t)
 
 	files_list_pids($1)
 	admin_pattern($1, tftpd_var_run_t)
+
+	tftp_manage_config($1)
 ')
